<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_MultimediaContent ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_MultimediaContent extends AbstractStructArrayBase
{
    /**
     * The MultimediaContent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_MultimediaContent[]
     */
    public $MultimediaContent;
    /**
     * Constructor method for ArrayOfJP_MultimediaContent
     * @uses ArrayOfJP_MultimediaContent::setMultimediaContent()
     * @param \StructType\JP_MultimediaContent[] $multimediaContent
     */
    public function __construct(array $multimediaContent = array())
    {
        $this
            ->setMultimediaContent($multimediaContent);
    }
    /**
     * Get MultimediaContent value
     * @return \StructType\JP_MultimediaContent[]|null
     */
    public function getMultimediaContent()
    {
        return $this->MultimediaContent;
    }
    /**
     * This method is responsible for validating the values passed to the setMultimediaContent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMultimediaContent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMultimediaContentForArrayConstraintsFromSetMultimediaContent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_MultimediaContentMultimediaContentItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_MultimediaContentMultimediaContentItem instanceof \StructType\JP_MultimediaContent) {
                $invalidValues[] = is_object($arrayOfJP_MultimediaContentMultimediaContentItem) ? get_class($arrayOfJP_MultimediaContentMultimediaContentItem) : sprintf('%s(%s)', gettype($arrayOfJP_MultimediaContentMultimediaContentItem), var_export($arrayOfJP_MultimediaContentMultimediaContentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MultimediaContent property can only contain items of type \StructType\JP_MultimediaContent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MultimediaContent value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_MultimediaContent[] $multimediaContent
     * @return \ArrayType\ArrayOfJP_MultimediaContent
     */
    public function setMultimediaContent(array $multimediaContent = array())
    {
        // validation for constraint: array
        if ('' !== ($multimediaContentArrayErrorMessage = self::validateMultimediaContentForArrayConstraintsFromSetMultimediaContent($multimediaContent))) {
            throw new \InvalidArgumentException($multimediaContentArrayErrorMessage, __LINE__);
        }
        $this->MultimediaContent = $multimediaContent;
        return $this;
    }
    /**
     * Add item to MultimediaContent value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_MultimediaContent $item
     * @return \ArrayType\ArrayOfJP_MultimediaContent
     */
    public function addToMultimediaContent(\StructType\JP_MultimediaContent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_MultimediaContent) {
            throw new \InvalidArgumentException(sprintf('The MultimediaContent property can only contain items of type \StructType\JP_MultimediaContent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MultimediaContent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_MultimediaContent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_MultimediaContent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_MultimediaContent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_MultimediaContent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_MultimediaContent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MultimediaContent
     */
    public function getAttributeName()
    {
        return 'MultimediaContent';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_MultimediaContent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
